###############################################################################
###############################################################################
##
##  Copyright (C) 2004-2009 Red Hat, Inc.  All rights reserved.
##
##  This copyrighted material is made available to anyone wishing to use,
##  modify, copy, or redistribute it subject to the terms and conditions
##  of the GNU General Public License v.2.
##
###############################################################################
###############################################################################
Source10: kmodtool2
%define kmodtool bash %{SOURCE10}

## TODO: this will need to match RHEL6 kernel version
## now based on latest F12 kernel as of Oct 2 2009

# hint: this can he overridden with "--define kversion foo" on the rpmbuild command line, e.g.
# --define "kversion 2.6.16-1.2096_FC5"
%{!?kversion: %define kversion 2.6.31.1-56.fc12}

# define variants
%define kmod_name gfs
%define kverrel %(%{kmodtool} verrel %{?kversion} 2>/dev/null)

## TODO: review variants. There are no kdump or xen kernels in Fedora
%define upvar ""
%ifarch ppc
%define smpvar smp
%endif
## ifarch i686 x86_64 ia64
## define xenvar xen
## define kdumpvar kdump
## endif
%ifarch i686
%define PAEvar PAE
%endif

# hint: this can he overridden with "--define kvariant foo bar" on the rpmbuild command line, e.g.
# --define 'kvariant "" smp'
%{!?kvariants: %define kvariants %{?upvar} %{?smpvar} %{?xenvar} %{?kdumpvar} %{?PAEvar}}

Name: %{kmod_name}-kmod
Version: 3.0.3
Release: 1%{?dist}
Summary: %{kmod_name} kernel modules
Group: System Environment/Kernel
License: GPLv2+
URL: http://sources.redhat.com/cluster/wiki/
Source0: gfs-utils-%{version}.tar.gz
## TODO: review Arches
ExclusiveArch: i686 x86_64 ia64 ppc64 ppc64iseries s390x

BuildRoot: %(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)

%description
gfs - The Global File System is a symmetric, shared-disk, cluster file
system.

# magic hidden here:
%{expand:%(%{kmodtool} rpmtemplate_kmp %{kmod_name} %{kverrel} %{_target_cpu} %{kvariants} 2>/dev/null)}

%prep
# to understand the magic better or to debug it, uncomment this:
# %{kmodtool} rpmtemplate_kmp %{kmod_name} %{kverrel} %{_target_cpu} %{kvariants} 2>/dev/null
# sleep 5

%setup -q -c -T -a 0

# Makefile fixup:
# - match RHEL5/6 kmods location (KDIRT)
# - don't install kmod-gfs headeers (KHEADT)
sed -i \
	-e 's/^KDIRT.*/KDIRT=/g' \
	-e 's/^KHEADT.*//g' \
	%{kmod_name}-utils-%{version}/gfs-kernel/src/gfs/Makefile

for kvariant in %{kvariants} ; do
	cp -a %{kmod_name}-utils-%{version} _kmod_build_${kvariant}
done

%build
for kvariant in %{kvariants}; do
	ksrc=%{_usrsrc}/kernels/%{kverrel}.%{_target_cpu}${kvariant:+.$kvariant}
	pushd _kmod_build_$kvariant
	./configure \
		--kernel_src=${ksrc} \
		--kernel_build=${ksrc} \
		--module_dir=/lib/modules/%{kverrel}.%{_target_cpu}${kvariant:+.$kvariant}/extra/%{kmod_name} \
		--libdir=%{_libdir} \
		--without_fence_agents
	make -C gfs-kernel/src/gfs all
	popd
done

%install
rm -rf %{buildroot}
for kvariant in %{kvariants}; do
	pushd _kmod_build_$kvariant
	make -C gfs-kernel/src/gfs install \
		DESTDIR=%{buildroot}
	popd
done
# Temporarily executable for stripping, fixed later in %%files.
chmod u+x %{buildroot}/lib/modules/*/extra/%{kmod_name}/*

%clean
rm -rf %{buildroot}

%changelog
* Fri Oct  2 2009 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.3-1
- Update to latest stable release
- cleanup spec file

* Thu Jul 23 2009 Chris Feist <cfeist@redhat.com> - 0.1.34-1
- fsyncs to stuffed inodes now cause the journal to be flushed.
- Resolves: rhbz#510310

* Mon Jun 08 2009 Chris Feist <cfeist@redhat.com> - 0.1.33-1
- vmalloc is now used instead of kmalloc to prevent page allocation failures.
- Resolves: rhbz#479421

* Mon May 04 2009 Chris Feist <cfeist@redhat.com> - 0.1.32-1
- Reduced the potential for a deadlock by prefaulting buffer pages preventing
  a hang on 'wait_for_completion'.
- An issue with apache reading files with the inherit_jdata flag has been fixed
- Resolves: rhbz#472062 rhbz#436811

* Tue Nov 11 2008 Chris Feist <cfeist@redhat.com> - 0.1.31-1
- Fixed a hang in GFS due to wasteful prefetching of locks.

* Mon Nov 10 2008 Chris Feist <cfeist@redhat.com> - 0.1.30-1
- gfs_lock() now handles F_CANCELLK correctly.
- Resolves: rhbz#466677

* Thu Nov 06 2008 Chris Feist <cfeist@redhat.com> - 0.1.29-1
- Provide backwards compatability with older gfs-kmod packages.
- Resolves: rhbz#462892

* Tue Oct 14 2008 Chris Feist <cfeist@redhat.com> - 0.1.28-1
- More fixes for the noatime/nodiratime mount options.
- Resolves: rhbz#457473

* Mon Oct 06 2008 Chris Feist <cfeist@redhat.com> - 0.1.26-1
- noatime and nodiratime mount options have been fixed.
- Resolves: rhbz#457473

* Mon Sep 15 2008 Chris Feist <cfeist@redhat.com> - 0.1.25-1
- Fixed GFS unlinked inode metadata leak
- Resolves: rhbz#298931

* Thu Jul 31 2008 Chris Feist <cfeist@redhat.com> - 0.1.24-1
- Created gfs1 specific lock modules
- Fixed a bug causing an "unable to handle kernel paging request" message.
- Faster bitfit algorithm has been added.
- Don't cancel glocks when writing to a hidden file.
- gfs_mount no longer hangs when run if no more journals are available.
- gfs-kernel now uses device major:minor
- Fixed the gfs_glock_is_locked_by_me assertion.
- Resolves: rhbz#450209 rhbz#446085 rhbz#446085 rhbz#425421 rhbz#431952 rhbz#429343

* Thu Jan 24 2008 Chris Feist <cfeist@redhat.com> - 0.1.22-1
- gfs_tool now recognizes GFS files sytems on ppc
- Fixed a NULL pointer dereference.
- gfs_quota is now able to perform efficient list operations
- Resolves: rhbz#429633 rhbz#426291 rhbz#430134

* Mon Jan 14 2008 Chris Feist <cfeist@redhat.com> - 0.1.21-1
- Lock methods are now removed when using the lock_nolock protocol
- Permission checks have been removed from xattr operations
- Locking order in gfs_get_parent() has been fixed
- Resolves: rhbz#244343 rhbz#323111 rhbz#400651

* Tue Oct 02 2007 Chris Feist <cfeist@redhat.com> - 0.1.19-7
- Build for new kernel (2.6.18-53.el5)
- Related: rhbz#267001

* Wed Sep 12 2007 Chris Feist <cfeist@redhat.com> - 0.1.19-5
- Build for new kernel (2.6.18-47.el5)
- Resolves: rhbz#267001

* Mon Jul 23 2007 Chris Feist <cfeist@redhat.com> - 0.1.19-4
- Build for new kernel (2.6.18-36.el5)
- Resolves: rhbz#249333

* Fri Jul 13 2007 Jon Masters <jcm@redhat.com> - 0.1.19-3
- Fix problem calling RPM from within Anaconda.

* Mon Jan 15 2007 Chris Feist <cfeist@redhat.com> - 0.1.16-3
- Build based in kABI deps using code from jcm@redhat.com

* Thu Dec 21 2006 Chris Feist <cfeist@redhat.com> - 0.1.16-1
- New sources
- Resolves: rhbz#219876

* Mon Dec 19 2006 Chris Feist <cfeist@redhat.com> - 0.1.15-1
- Building for PAE kernel
- Resolves: rhbz#218551

* Fri Dec 08 2006 Chris Feist <cfeist@redhat.com> - 0.1.14-3
- Building for PAE kernel
- Resolves: rhbz#218986

* Mon Dec 04 2006 Chris Feist <cfeist@redhat.com> - 0.1.14-1
- Built for new kernel
- Resolves: rhbz#217893 rhbz#215962

* Thu Nov 28 2006 Chris Feist <cfeist@redhat.com> - 0.1.13-2
- Built for new kernel
- Resolves: rhbz#217893

* Mon Nov 20 2006 Chris Feist <cfeist@redhat.com> - 0.1.13-1
- New upstream sources.

* Fri Oct 27 2006 Chris Feist <cfeist@redhat.com> - 0.1.11-1
- New upstream sources.

* Mon Oct 16 2006 Chris Feist <cfeist@redhat.com> - 0.1.7-1
- New upstream sources to fix AIO issues.

* Mon Oct 16 2006 Chris Feist <cfeist@redhat.com> - 0.1.6-1
- New upstream sources.

* Fri Oct 13 2006 Chris Feist <cfeist@redhat.com> - 0.1.5-1
- New upstream sources.

* Mon Oct 9 2006 Chris Feist <cfeist@redhat.com> - 0.1.4-1
- New upstream sources (fixes selinux issue).

* Fri Oct 6 2006 Chris Feist <cfeist@redhat.com> - 0.1.3-8
- Temporarily disable ppc builds.

* Wed Sep 27 2006 Chris Feist <cfeist@redhat.com> - 0.1.3-7
- Use version-release instead of <CVS> for release name.

* Mon Sep 25 2006 Chris Feist <cfeist@redhat.com> - 0.1.3-1
- Add support for ia64 xen.
- New upstream sources.

* Thu Sep 21 2006 Tim Powers <timp@redhat.com> - 0.1.2-5
- rebuild for kernel-2.6.18-1.2685.el5

* Wed Sep 20 2006 Tim Powers <timp@redhat.com> - 0.1.2-4
- bump and rebuild

* Mon Sep 18 2006 Chris Feist <cfeist@redhat.com> - 0.1.2-3
- Enable xen builds.

* Wed Sep 13 2006 Chris Feist <cfeist@redhat.com> - 0.1.2-1
- New upstream sources.

* Wed Aug 30 2006 Chris Feist <cfeist@redhat.com> - 0.1.1-9
- bump and rebuild against kernel-2.6.17-1.2519.4.21.el5

* Tue Aug 29 2006 Dennis Gregorovic <dgregor@redhat.com> - 0.1.1-9
- bump and rebuild against kernel-2.6.17-1.2519.4.18.el5

* Fri Aug 25 2006 Chris Feist <cfeist@redaht.com> - 0.1.1-8
- Don't build for kdump kernel

* Fri Aug 18 2006 Tim Powers <timp@redhat.com> - 0.1.1-7
- bump and rebuild against kernel-2.6.17-1.2519.4.5.el5

* Thu Aug 17 2006 Chris Feist <cfeist@redhat.com> - 0.1.1-6
- Built for new kernel.

* Tue Aug 15 2006 Chris Feist <cfeist@redhat.com> - 0.1.1-5
- Don't require kmod-gfs-common for now.

* Tue Aug 15 2006 Chris Feist <cfeist@redhat.com> - 0.1.1-4
- Added a provides for gfs-kmod-common

* Fri Aug 11 2006 Chris Feist <cfeist@redhat.com> - 0.1.1-0
- New upstream sources.

* Fri Aug 4 2006 Chris Feist <cfeist@redhat.com> - 0.1.0-3
- Re-enable other kernel types & disabled broken xen build

* Thu Aug 3 2006 Chris Feist <cfeist@redhat.com> - 0.1.0-2
- Initial Build
